Subject: [OSPF] draft-zzhang-ospf-two-part-metric

From: "Jeffrey (Zhaohui) Zhang" <[email-masked]>
Date: Thu, 8 May 2014 19:32:53 +0000

Hi,

Finally I am getting back to this draft after the London meeting.

I believe in London we got good understanding of the problem and solution, but need further discussions on how to encode the from-network cost.

Option 1 is to encode as an MT metric (slide #9, http://www.ietf.org/proceedings/89/slides/slides-89-ospf-4.pdf). It is straightforward for IPv4, but requires Extended LSA support for IPv6.

Option 2 is to encode as Stub Link metric (slide #10). Again it is straightforward for IPv4 but for IPv6 it needs a bit more elaboration that I did not do in London (thanks for Abhay to point out that it is different for IPv6).

I am leaning toward Option 2, so that an implementation of this feature does not have to rely on the bigger changes needed for Extended LSA. Before I put the details into the draft and present it in Toronto, I'd like to outline it here to start the discussion.

Currently, RFC 5340 states that only the DR will advertise the prefixes for a transit network in the intra-area-prefix-lsa. The proposed change is to allow non-DRs to also do that, with the same reference info as the DR includes for the corresponding prefixes in its intra-area-prefix-lsa, but the metric is set to the from-network cost. For the DR itself, it also sets the metric to its from-network cost (instead of 0) in corresponding prefixes in its intra-area-prefix-lsa.

The above assumes that each router independently obtains and advertises its from-network cost. For certain networks that this feature applies to, the underlying protocol (e.g. radio control protocol for a satellite network) may be able to obtain individual from-network costs in a centralized fashion and communicate that out of band to the DR. To take advantage of that, a DR could also advertise the from-network costs for each router in its own intra-area-prefix-lsa, so that when an affecting-all event happens to cause everyone's from-network cost to change, only the DR needs to update its intra-area-prefix-lsa (to reduce the flooding of multiple intra-area-prefix-lsa).

To achieve that, when the DR examines each link-lsa associated with the link as described in 4.4.3.9 of RFC 5340, in addition to advertising a single "primary" prefix (out of duplicated ones described in the link-lsa's), different prefix entries are also advertised, with the reference info set to (0x2002, DR's Interface ID, adjacent router's RouterID). The prefix in those entries will all be the same, and the metric is set to the from-network cost.

The difference of those additional prefix entries from the "primary" one is that the Reference Advertising Router is an adjacent router but not the DR itself.

During SPF calculation, when a router vertex is reached from a network vertex, the rouer's from-network cost is determined the following way:

- Look up the intra-area-prefix-lsa advertised by the DR, and look for a matching prefix from the above additional special prefix entries.
- If not found, look up the intra-area-prefix-lsa advertised by the router, and look for prefix entry that references the corresponding network lsa.

Any prefixes in the intra-area-prefix-lsa with the Referenced Advertising Router not matching the advertiser of the intra-area-prefix-lsa will be ignored for all other purposes. They are only used to obtain the from-network cost.

Comments?

Thanks.
Jeffrey